//+------------------------------------------------------------------+
//|                                             DidiIndexHedgeEA.mq5 |
//|                                                           suvroc |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "suvroc"
#property link      ""
#property version   "1.00"

#include <myFunctions.mqh>
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
// GLOBAL VARS

sinput group                              "EA GENERAL SETTINGS"
input ulong                               MagicNumber             = 101;
input bool                                UseFillingPolicy        = false;
input ENUM_ORDER_TYPE_FILLING             FillingPolicy           = ORDER_FILLING_FOK;

sinput group                              "ATR SETTINGS";
input int                                 atrPeriod = 14;
input int                                 shiftAtr  = 0;

sinput group                              "1st CONFIRMATION INDICATOR PARAMETERS";
input ENUM_APPLIED_PRICE                  didiSource = PRICE_CLOSE;
input int                                 didiMeanMa = 8;
input int                                 didiSlowMa = 20;

double atrValue;
int atrHandle; 
int didiHandle;

string entrySignal;
datetime    glTimeBarOpen;
   
//---
int OnInit()
  {
//---
   glTimeBarOpen = D'1971.01.01 00:00';
   string indiPath = "DidiIndex.ex5";
   atrHandle = iATR(_Symbol,PERIOD_CURRENT,atrPeriod);
   
   didiHandle = iCustom(_Symbol,PERIOD_CURRENT,indiPath,PERIOD_CURRENT,0, didiSource, 0 , 3, didiMeanMa, didiSlowMa);
   if(didiHandle == INVALID_HANDLE)
     {
         Print("FAILED TO INIT DIDI INDEX INDICATOR");
         return (INVALID_HANDLE);
     }
   
   if (atrHandle == INVALID_HANDLE) 
   {
      Print("FAILED TO INIT ATR INDICATOR");
      return (INVALID_HANDLE);
   }
      
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
//+------------------------------------------------------------------+
//| 1. ATR                                         |
//+------------------------------------------------------------------+
   
   atrValue = NormalizeDouble(myAtr(atrHandle,shiftAtr),_Digits);
   Comment("ATR : ", atrValue);
   
//+------------------------------------------------------------------+
//| 2. TESTED INDICATOR                                              |
//+------------------------------------------------------------------+
      //--------------------//
   //  NEW BAR CONTROL   //
   //--------------------//

      

      
  
   
   bool newBar = false;
   
   //Check for New Bar
   if(glTimeBarOpen != iTime(Symbol(),PERIOD_CURRENT,0))
   {
      newBar = true;
      glTimeBarOpen = iTime(Symbol(),PERIOD_CURRENT,0);   
   }   
   
   if(newBar == true)
   {

      //double myBuffer[];
      //CopyBuffer(didiHandle,2,0,2,myBuffer);
     // bool cross = DetectCrossover(myBuffer,2);
      //Print("DIDI SIGNAL : ", myBuffer[1]);
      entrySignal = zeroCross(didiHandle,2,1.00, glTimeBarOpen);
      
      Comment("EA #", MagicNumber, " | ",entrySignal, " SIGNALS DETECTED");
      
      if((entrySignal == "LONG" || entrySignal == "SHORT") && CheckPlacedPositions(MagicNumber) == false)
      {
         ulong ticket = OpenTrades(entrySignal,MagicNumber,1, UseFillingPolicy, FillingPolicy);  
         
         //SL & TP Trade Modification
         if(ticket > 0)
         {
            double stopLoss = CalculateStopLoss(entrySignal, atrValue * 1.5);
            double takeProfit = CalculateTakeProfit(entrySignal, atrValue);
            TradeModification(ticket,MagicNumber,stopLoss,takeProfit);         
         }
      }

              
      
   
   }
//+------------------------------------------------------------------+
//| 2. ORDER MANAGEMENT                                              |
//+------------------------------------------------------------------+

  }
//+------------------------------------------------------------------+
